﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace Delta.Tools
{
    public partial class Generic
    {
        private void Grid_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            Grid grid = (Grid)sender;
            Grid rootGrid = (Grid)grid.Parent;
            TranslateTransform translate = ((TranslateTransform)rootGrid.RenderTransform);
            Storyboard sb;

            if (translate.Y == 10)
                sb = (Storyboard)rootGrid.Resources["HideStoryboard"];
            else
                sb = (Storyboard)rootGrid.Resources["ShowStoryboard"];

            sb.Begin();
        }

        private void RootGrid_Loaded(object sender, RoutedEventArgs e)
        {
            Grid rootgrid = (Grid)sender;
            double targetHeight = rootgrid.ActualHeight + 4;
            TranslateTransform translate = ((TranslateTransform)rootgrid.RenderTransform);
            translate.Y = targetHeight;

            Storyboard sb = (Storyboard)rootgrid.Resources["HideStoryboard"];
            DoubleAnimation anim = (DoubleAnimation)sb.Children[0];

            anim.To = targetHeight;
        }

        private void RootGrid_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            if (e.NewSize.Height != e.PreviousSize.Height)
            {
                Grid rootgrid = (Grid)sender;
                Storyboard sb = (Storyboard)rootgrid.Resources["HideStoryboard"];
                DoubleAnimation anim = (DoubleAnimation)sb.Children[0];

                anim.To = e.NewSize.Height + 4;

                TranslateTransform translate = ((TranslateTransform)rootgrid.RenderTransform);
                if (translate.Y != 10)
                {
                    translate.SetCurrentValue(TranslateTransform.YProperty, e.NewSize.Height + 4);
                }
            }
        }

        private void Bottom_Grid_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            Grid grid = (Grid)sender;
            Grid rootGrid = (Grid)grid.Parent;
            TranslateTransform translate = ((TranslateTransform)rootGrid.RenderTransform);
            Storyboard sb;

            if (translate.Y == -10)
                sb = (Storyboard)rootGrid.Resources["HideStoryboard"];
            else
                sb = (Storyboard)rootGrid.Resources["ShowStoryboard"];

            sb.Begin();
        }

        private void Bottom_RootGrid_Loaded(object sender, RoutedEventArgs e)
        {
            Grid rootgrid = (Grid)sender;
            double targetHeight = -rootgrid.ActualHeight - 5;
            TranslateTransform translate = ((TranslateTransform)rootgrid.RenderTransform);
            translate.Y = targetHeight;

            Storyboard sb = (Storyboard)rootgrid.Resources["HideStoryboard"];
            DoubleAnimation anim = (DoubleAnimation)sb.Children[0];

            anim.To = targetHeight;
        }

        private void Bottom_RootGrid_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            if (e.NewSize.Height != e.PreviousSize.Height)
            {
                Grid rootgrid = (Grid)sender;
                Storyboard sb = (Storyboard)rootgrid.Resources["HideStoryboard"];
                DoubleAnimation anim = (DoubleAnimation)sb.Children[0];

                anim.To = -e.NewSize.Height - 5;

                TranslateTransform translate = ((TranslateTransform)rootgrid.RenderTransform);
                if (translate.Y != -10)
                {
                    translate.SetCurrentValue(TranslateTransform.YProperty, -e.NewSize.Height - 5);
                }
            }
        }

        private void Left_RootGrid_Loaded(object sender, RoutedEventArgs e)
        {
            Grid rootgrid = (Grid)sender;
            double targetWidth = rootgrid.ActualWidth + 4;
            TranslateTransform translate = ((TranslateTransform)rootgrid.RenderTransform);
            translate.X = targetWidth;

            Storyboard sb = (Storyboard)rootgrid.Resources["HideStoryboard"];
            DoubleAnimation anim = (DoubleAnimation)sb.Children[0];

            anim.To = targetWidth;
        }

        private void Left_Grid_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            Grid grid = (Grid)sender;
            Grid rootGrid = (Grid)grid.Parent;
            TranslateTransform translate = ((TranslateTransform)rootGrid.RenderTransform);
            Storyboard sb;

            if (translate.X == 10)
                sb = (Storyboard)rootGrid.Resources["HideStoryboard"];
            else
                sb = (Storyboard)rootGrid.Resources["ShowStoryboard"];

            sb.Begin();
        }

        private void Left_RootGrid_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            if (e.NewSize.Width != e.PreviousSize.Width)
            {
                Grid rootgrid = (Grid)sender;
                Storyboard sb = (Storyboard)rootgrid.Resources["HideStoryboard"];
                DoubleAnimation anim = (DoubleAnimation)sb.Children[0];

                anim.To = e.NewSize.Width + 4;                

                TranslateTransform translate = ((TranslateTransform)rootgrid.RenderTransform);
                if (translate.X != 10)
                {
                    translate.SetCurrentValue(TranslateTransform.XProperty, e.NewSize.Width + 4);
                }
            }
        }
    }
}
