﻿using System;
using UrzaIncubator;

namespace UrzaGatherer.ViewModels
{
    public class DialogSystem
    {
        Func<string, string, string> queryFunc;
        Func<string, string, bool> questionFunc;
        Action editCardAction;
        Action<string, string> showMessageAction;
        Action<bool> showWaitCursorAction;

        public void RegisterQueryFunc(Func<string, string, string> func)
        {
            queryFunc = func;
        }

        public void RegisterQuestionFunc(Func<string, string, bool> func)
        {
            questionFunc = func;
        }

        public void RegisterEditCardAction(Action action)
        {
            editCardAction = action;
        }

        public void RegisterShowMessageAction(Action<string, string> action)
        {
            showMessageAction = action;
        }

        public void RegisterShowWaitCursorAction(Action<bool> action)
        {
            showWaitCursorAction = action;
        }

        public string Query(string question, string title)
        {
            return queryFunc(question, title);
        }

        public bool Question(string question, string title)
        {
            return questionFunc(question, title);
        }

        public void Message(string message, string title)
        {
            showMessageAction(message, title);
        }

        public void ShowWaitCursor(bool wait)
        {
            showWaitCursorAction(wait);
        }

        public void EditCard()
        {
            editCardAction();
        }
    }
}
