﻿using System;
using System.Windows;
using System.Windows.Media.Animation;

namespace UrzaGatherer
{
    public class AnimationUtils
    {
        public static DoubleAnimationUsingKeyFrames CreateDoubleAnimation(DependencyObject target, Double to, PropertyPath propertyPath, Duration duration, IEasingFunction easingFunction)
        {
            DoubleAnimationUsingKeyFrames animation = new DoubleAnimationUsingKeyFrames();
            animation.Duration = duration;
            Storyboard.SetTarget(animation, target);
            Storyboard.SetTargetProperty(animation, propertyPath);

            EasingDoubleKeyFrame kf1 = new EasingDoubleKeyFrame();
            kf1.KeyTime = duration.TimeSpan;
            kf1.Value = to;
            kf1.EasingFunction = easingFunction;

            animation.KeyFrames.Add(kf1);

            return animation;
        }

        public static ObjectAnimationUsingKeyFrames CreateVisibilityAnimation(DependencyObject target, TimeSpan duration, Visibility visibility)
        {
            ObjectAnimationUsingKeyFrames visibilityAnimation = new ObjectAnimationUsingKeyFrames();

            Storyboard.SetTarget(visibilityAnimation, target);
            Storyboard.SetTargetProperty(visibilityAnimation, new PropertyPath("(UIElement.Visibility)"));

            DiscreteObjectKeyFrame kfVisibility = new DiscreteObjectKeyFrame();

            kfVisibility.KeyTime = KeyTime.FromTimeSpan(duration);
            kfVisibility.Value = visibility;
            visibilityAnimation.KeyFrames.Add(kfVisibility);

            return visibilityAnimation;
        }
    }
}
