﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using UrzaIncubator;

namespace UrzaGatherer
{
    public class ColorConverter :IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null)
                return null;

            string colorName;
            Color color = value as Color;

            if (color == null)
            {
                colorName = value.ToString();
            }
            else
            {
                colorName = color.Name;
            }

            return new BitmapImage(new Uri(string.Format("/UrzaGatherer;component/Colors/{0}.gif", colorName), UriKind.Relative));
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}
