﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using UrzaIncubator;

namespace UrzaGatherer
{
    public class RarityConverter :IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Rarity rarity = value as Rarity;

            if (rarity == null)
                return new SolidColorBrush(Colors.Black);

            switch (rarity.Name)
            {
                case "Special":
                    return new SolidColorBrush(Colors.Purple);
                case "Mythic Rare":
                    return new SolidColorBrush(Colors.OrangeRed);
                case "Rare":
                    return new SolidColorBrush(Colors.Goldenrod);
                case "Uncommon":
                    return new SolidColorBrush((System.Windows.Media.Color)System.Windows.Media.ColorConverter.ConvertFromString("#FF555555"));
                default:
                    return new SolidColorBrush(Colors.Black);

            }
            
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}