﻿using System.Diagnostics;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using Ookii.Dialogs.Wpf;

namespace UrzaGatherer
{
    /// <summary>
    /// Interaction logic for InstallDatabaseWindow.xaml
    /// </summary>
    public partial class InstallDatabaseWindow
    {
        public InstallDatabaseWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            VistaOpenFileDialog fileDialog = new VistaOpenFileDialog();
            if (fileDialog.ShowDialog(this) == true)
            {
                backupFileText.Text = fileDialog.FileName;
                OKButton.IsEnabled = true;
            }
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            Cursor = Cursors.Wait;
            string backup = backupFileText.Text;
            Task task = Task.Factory.StartNew(() => UrzaIncubator.Tools.Restore(backup));
            task.Wait();
            Cursor = Cursors.Arrow;
            DialogResult = true;
        }

        private void Hyperlink_RequestNavigate(object sender, System.Windows.Navigation.RequestNavigateEventArgs e)
        {
            Process.Start(e.Uri.ToString());
        }
    }
}
