﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;

namespace UrzaGatherer
{
    partial class Styles
    {
        private void HeaderSite_Checked(object sender, RoutedEventArgs e)
        {
            FrameworkElement element = sender as FrameworkElement;
            StackPanel parent = element.Parent as StackPanel;
            Grid grid = (Grid)(parent.Children[1]);
            ContentPresenter contentPresenter = (ContentPresenter)grid.Children[0];

            FrameworkElement uiElement = (FrameworkElement)contentPresenter.Content;

            DoubleAnimation animation = new DoubleAnimation(Math.Max(100, uiElement.MaxHeight), TimeSpan.FromMilliseconds(300.0));
            BackEase backEase = new BackEase {Amplitude = 0.4, EasingMode = EasingMode.EaseInOut};
            animation.EasingFunction = backEase;

            grid.BeginAnimation(FrameworkElement.HeightProperty, animation);
        }

        private void HeaderSite_Unchecked(object sender, RoutedEventArgs e)
        {
            FrameworkElement element = sender as FrameworkElement;
            StackPanel parent = element.Parent as StackPanel;
            Grid grid = (Grid)(parent.Children[1]);

            DoubleAnimation animation = new DoubleAnimation(0, TimeSpan.FromMilliseconds(300.0));
            BackEase backEase = new BackEase {Amplitude = 0.4, EasingMode = EasingMode.EaseIn};
            animation.EasingFunction = backEase;

            grid.BeginAnimation(FrameworkElement.HeightProperty, animation);
        }
    }
}
