﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Threading;
using mshtml;
using UrzaIncubator;

namespace UrzaGatherer
{
    internal static class Utilities
    {
        public static void DoEvents()
        {
            Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, new ThreadStart(delegate { }));
        }

        public static bool SetSelected(ItemsControl parent, object child)
        {
            if (parent == null || child == null)
            {
                return false;
            }

            TreeViewItem childNode = parent.ItemContainerGenerator.ContainerFromItem(child) as TreeViewItem;

            if (childNode != null)
            {
                childNode.Focus();
                return childNode.IsSelected = true;
            }

            if (parent.Items.Count > 0)
            {
                foreach (object childItem in parent.Items)
                {
                    ItemsControl childControl = parent.ItemContainerGenerator.ContainerFromItem(childItem) as ItemsControl;
                    if (SetSelected(childControl, child))
                    {
                        return true;
                    }
                }
            }
            return false;
        }
       
        public static void ChangeImage(Card card, DragEventArgs e)
        {
            try
            {
                string[] datas = (string[])e.Data.GetData("FileName");

                card.Image = File.ReadAllBytes(datas[0]);

            }
            catch (Exception)
            {
                MessageWindow.Show("Unable to update image.", "Urza Gatherer", null);
            }
        }

        public static List<IHTMLElement> GetElementsByClass(this IHTMLElement root, string id)
        {
            List<IHTMLElement> result = new List<IHTMLElement>();
            foreach (IHTMLElement el in (IHTMLElementCollection)root.all)
            {
                if (!string.IsNullOrEmpty(el.className) && el.className.ToLower() == id.ToLower())
                {
                    result.Add(el);
                }
            }

            return result;
        }
    }
}
