﻿using System.Windows;

namespace UrzaGatherer
{
    public partial class ProgressWindow
    {
        static ProgressWindow windowNonModal;
        public ProgressWindow()
        {
            InitializeComponent();
        }

        public string Message
        {
            set
            {
                TitleText.Text = value;
            }
        }
        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
        }

        public static void Show(string message, string title, Window owner)
        {
            MessageWindow window = new MessageWindow();

            window.Message = message;
            window.Title = title;
            window.Owner = owner;

            window.ShowDialog();
        }

        public static void Show(string message)
        {
            windowNonModal = new ProgressWindow();

            windowNonModal.Message = message;

            windowNonModal.Show();
        }

        public static double Progress
        {
            set
            {
                if (windowNonModal == null)
                    return;
                
                windowNonModal.progress.Value = value;
            }
        }

        public static void HideProgress()
        {
            if (windowNonModal == null)
                return;

            windowNonModal.Close();
            windowNonModal = null;
        }
    }
}
