﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace UrzaIncubator.JSON
{
    [DataContract]
    public class JSONBlock
    {
        [DataMember]
        public int id { get; set; }

        [DataMember]
        public string name { get; set; }

        [DataMember]
        public int index { get; set; }

        [DataMember]
        public JSONExpansion[] expansions { get; set; }

        public JSONBlock(Block block)
        {
            id = block.ID;
            name = block.Name;
            index = block.Index;

            expansions = block.Expansions.Select(e=>(JSONExpansion)e).ToArray();

            Array.Sort(expansions, (e0, e1)=>
            {
                if (e0.orderInBlock > e1.orderInBlock)
                    return 1;
                if (e0.orderInBlock < e1.orderInBlock)
                    return -1;
                return 0;
            });
        }
    }
}
