﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace UrzaIncubator.JSON
{
    [DataContract]
    public class JSONExpansion
    {
        [DataMember]
        public int id { get; set; }

        [DataMember]
        public string name { get; set; }

        [DataMember]
        public int orderInBlock { get; set; }

        [DataMember]
        public JSONCard[] cards { get; set; }

        [DataMember]
        public double internalTotalPrice { get; set; }

        [DataMember]
        public string logoPath { get; set; }

        public JSONExpansion(Expansion expansion)
        {
            id = expansion.ID;
            name = expansion.Name;
            orderInBlock = expansion.OrderInBlock;

            logoPath = "logos\\" + name.Replace(":", "_") + ".png";

            cards = expansion.Cards.Select(c=>(JSONCard)c).ToArray();

            internalTotalPrice = cards.Sum(c => c.price ?? 0);
        }

        public static implicit operator JSONExpansion(Expansion expansion)
        {
            return new JSONExpansion(expansion);
        }
    }
}
