﻿using System.Linq;
using System.Runtime.Serialization;

namespace UrzaIncubator.JSON.Minified
{
    [DataContract]
    public class JSONBlock
    {
        [DataMember]
        public string name { get; set; }

        [DataMember]
        public int index { get; set; }

        [DataMember]
        public JSONExpansion[] expansions { get; set; }

        public JSONBlock(Block block)
        {
            name = block.Name;
            index = block.Index;

            expansions = block.Expansions.Where(e=>!e.Name.Contains("Planechase")).Select(e=>(JSONExpansion)e).ToArray();
        }
    }
}
