﻿using System.Linq;
using System.Runtime.Serialization;

namespace UrzaIncubator.JSON.Minified
{
    [DataContract]
    public class JSONExpansion
    {
        [DataMember]
        public string name { get; set; }

        [DataMember]
        public JSONCard[] cards { get; set; }

        public JSONExpansion(Expansion expansion)
        {
            name = expansion.Name;

            cards = expansion.Cards.Select(c=>(JSONCard)c).ToArray();
        }

        public static implicit operator JSONExpansion(Expansion expansion)
        {
            return new JSONExpansion(expansion);
        }
    }
}
