﻿using System.Globalization;
using System.Windows;
using System.Windows.Media;

namespace UrzaIncubator.Rendering
{
    internal class DrawingZone
    {
        readonly int _width;
        readonly DrawingContext _drawingContext;
        readonly int _maxWidth;

        public DrawingZone(int width, DrawingContext drawingContext, int maxWidth)
        {
            _width = width;
            _maxWidth = maxWidth;
            _drawingContext = drawingContext;
        }

        public void DrawText(string text, int col, int row, int size, Brush brush)
        {
            int x = _width + col;
            int y = 4 + row * 30;
            FormattedText formattedText = new FormattedText(text, new CultureInfo("en-us"), FlowDirection.LeftToRight, new Typeface(new FontFamily("Segoe UI"), FontStyles.Normal, FontWeights.Normal, new FontStretch()), size, brush);

            formattedText.MaxTextWidth = _maxWidth;
            _drawingContext.DrawText(formattedText, new Point(x, y));
        }
    }
}
